| Kea 3.0.2-git

isc::dhcp::OptionDefListParser Class Reference

Parser for a list of option definitions. More...

`#include <dhcp_parsers.h>`

Inheritance diagram for isc::dhcp::OptionDefListParser:
[legend]

## Public Member Functions
| OptionDefListParser (const uint16_t address_family)
| Constructor.
void | parse (CfgOptionDefPtr cfg, isc::data::ConstElementPtr def_list)
| Parses a list of option definitions, create them and store in cfg.
Public Member Functions inherited from isc::data::SimpleParser
uint16_t | getUint16 (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a value converted to uint16_t.
uint32_t | getUint32 (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a value converted to uint32_t.
uint8_t | getUint8 (ConstElementPtr scope, const std::string &name)
| Get an uint8_t value.
const isc::util::Triplet< uint32_t > | parseIntTriplet (const data::ConstElementPtr &scope, const std::string &name)
| Parses an integer triplet.

## Additional Inherited Members
Static Public Member Functions inherited from isc::data::SimpleParser
static void | checkKeywords (const SimpleKeywords &keywords, isc::data::ConstElementPtr scope)
| Checks acceptable keywords with their expected type.
static void | checkRequired (const SimpleRequiredKeywords &required, isc::data::ConstElementPtr scope)
| Checks that all required keywords are present.
static size_t | deriveParams (isc::data::ConstElementPtr parent, isc::data::ElementPtr child, const ParamsList &params)
| Derives (inherits) parameters from parent scope to a child.
static isc::asiolink::IOAddress | getAddress (const ConstElementPtr &scope, const std::string &name)
| Returns a IOAddress parameter from a scope.
static bool | getBoolean (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a boolean parameter from a scope.
static double | getDouble (const ConstElementPtr &scope, const std::string &name)
| Returns a floating point parameter from a scope.
static int64_t | getInteger (isc::data::ConstElementPtr scope, const std::string &name)
| Returns an integer parameter from a scope.
static int64_t | getInteger (isc::data::ConstElementPtr scope, const std::string &name, int64_t min, int64_t max)
| Returns an integer parameter from a scope and checks its range.
static const data::Element::Position & | getPosition (const std::string &name, const data::ConstElementPtr parent)
| Utility method that returns position of an element.
static std::string | getString (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a string parameter from a scope.
static size_t | setDefaults (isc::data::ElementPtr scope, const SimpleDefaults &default_values)
| Sets the default values.
static size_t | setListDefaults (isc::data::ConstElementPtr list, const SimpleDefaults &default_values)
| Sets the default values for all entries in a list.
Protected Member Functions inherited from isc::data::SimpleParser
template<typename target_type, target_type convert>
target_type | getAndConvert (isc::data::ConstElementPtr scope, const std::string &name, const std::string &type_name)
| Returns a converted value from a scope.
template<typename int_type>
int_type | getIntType (isc::data::ConstElementPtr scope, const std::string &name)
| Returns an integer value with range checking from a scope.

## Detailed Description

Parser for a list of option definitions.

This parser iterates over all configuration entries that define option definitions and creates instances of these definitions. If the parsing is successful, the collection of created definitions is put into the provided storage.

Definition at line 254 of file dhcp_parsers.h.

## Constructor & Destructor Documentation

## ◆ OptionDefListParser()

isc::dhcp::OptionDefListParser::OptionDefListParser | ( | const uint16_t | address_family | ) |

Constructor.

Parameters

  address_family | Address family: `AF_INET` or `AF_INET6`.

Definition at line 278 of file dhcp_parsers.cc.

## Member Function Documentation

## ◆ parse()

void isc::dhcp::OptionDefListParser::parse | ( | CfgOptionDefPtr | cfg,
|  | isc::data::ConstElementPtr | def_list )

Parses a list of option definitions, create them and store in cfg.

This method iterates over def_list, which is a JSON list of option definitions, then creates corresponding option definitions and store them in the configuration structure.

Parameters

  def_list | JSON list describing option definitions
  cfg | parsed option definitions will be stored here

Definition at line 283 of file dhcp_parsers.cc.

References isc_throw, isc::dhcp::OptionDefParser::parse(), and isc::dhcp::LibDHCP::setRuntimeOptionDefs().

Referenced by isc::dhcp::processDhcp4Config(), and isc::dhcp::processDhcp6Config().

Here is the call graph for this function:

The documentation for this class was generated from the following files:

- dhcp_parsers.h
- dhcp_parsers.cc